#include "lib_ll.h"


int main(int argc, char** argv) {

    struct lattice lat;
    int count, changes, L, rnum;
    double rho;
    char* savefile;

    check_args(argc,argv);

    L=strtol(argv[1],NULL,10);
    rho=strtod(argv[2],NULL);
    rnum=strtoll(argv[3],NULL,10);
    savefile=argv[4];

    create_lattice(&lat,L,rho,rnum);

    changes=1;
    count=0;
    while(0 != changes&& count < COUNT_MAX) {
	changes=propagate_labels(&lat);
	count+=(changes>0);
    }

#ifdef PRINTOUT
    print_labels(&lat);
#endif
    fprintf(stdout,"iterations: %d\n",count);

    save_lattice(&lat,savefile);

    destroy_lattice(&lat);

    return 0;

}
