#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#ifndef COUNT_MAX
#define COUNT_MAX (100000000LL)
#endif

#define MULTIP (1181783497276652981ULL)
#define ECUYER(_x) (MULTIP*(unsigned long long)_x)
#define NORM(_x) ((5.4210108624275221e-20)*(double)(_x=ECUYER(_x)))


struct lattice {

    int* value;
    int* label;
    int L;
    double rho;
    int* oXp;
    int* oYp;
    int* oXm;
    int* oYm;

};

void check_args(int, char**);

void create_lattice (struct lattice*,int,double,int);
void destroy_lattice(struct lattice*);

void print_values(struct lattice*);
void print_labels(struct lattice*);
void save_lattice(struct lattice*, char*);

int propagate_labels(struct lattice* );

int update(struct lattice*, int, int);
